<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_RentacarLocationDetail ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_RentacarLocationDetail extends AbstractStructArrayBase
{
    /**
     * The RentacarLocationDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_RentacarLocationDetail[]
     */
    public $RentacarLocationDetail;
    /**
     * Constructor method for ArrayOfJP_RentacarLocationDetail
     * @uses ArrayOfJP_RentacarLocationDetail::setRentacarLocationDetail()
     * @param \StructType\JP_RentacarLocationDetail[] $rentacarLocationDetail
     */
    public function __construct(array $rentacarLocationDetail = array())
    {
        $this
            ->setRentacarLocationDetail($rentacarLocationDetail);
    }
    /**
     * Get RentacarLocationDetail value
     * @return \StructType\JP_RentacarLocationDetail[]|null
     */
    public function getRentacarLocationDetail()
    {
        return $this->RentacarLocationDetail;
    }
    /**
     * This method is responsible for validating the values passed to the setRentacarLocationDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRentacarLocationDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRentacarLocationDetailForArrayConstraintsFromSetRentacarLocationDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_RentacarLocationDetailRentacarLocationDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_RentacarLocationDetailRentacarLocationDetailItem instanceof \StructType\JP_RentacarLocationDetail) {
                $invalidValues[] = is_object($arrayOfJP_RentacarLocationDetailRentacarLocationDetailItem) ? get_class($arrayOfJP_RentacarLocationDetailRentacarLocationDetailItem) : sprintf('%s(%s)', gettype($arrayOfJP_RentacarLocationDetailRentacarLocationDetailItem), var_export($arrayOfJP_RentacarLocationDetailRentacarLocationDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RentacarLocationDetail property can only contain items of type \StructType\JP_RentacarLocationDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RentacarLocationDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarLocationDetail[] $rentacarLocationDetail
     * @return \ArrayType\ArrayOfJP_RentacarLocationDetail
     */
    public function setRentacarLocationDetail(array $rentacarLocationDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($rentacarLocationDetailArrayErrorMessage = self::validateRentacarLocationDetailForArrayConstraintsFromSetRentacarLocationDetail($rentacarLocationDetail))) {
            throw new \InvalidArgumentException($rentacarLocationDetailArrayErrorMessage, __LINE__);
        }
        $this->RentacarLocationDetail = $rentacarLocationDetail;
        return $this;
    }
    /**
     * Add item to RentacarLocationDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarLocationDetail $item
     * @return \ArrayType\ArrayOfJP_RentacarLocationDetail
     */
    public function addToRentacarLocationDetail(\StructType\JP_RentacarLocationDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_RentacarLocationDetail) {
            throw new \InvalidArgumentException(sprintf('The RentacarLocationDetail property can only contain items of type \StructType\JP_RentacarLocationDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RentacarLocationDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_RentacarLocationDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_RentacarLocationDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_RentacarLocationDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_RentacarLocationDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_RentacarLocationDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RentacarLocationDetail
     */
    public function getAttributeName()
    {
        return 'RentacarLocationDetail';
    }
}
